/*
Research Project:   Graphical Database for Category Theory
                    J. Bradbury, Dr. R. Rosebrugh, I. Rutherford
                    Mount Allison University 2001
File:               EndomorphismFrame.java
Description:	      This file is displayed when the user selects the "Endomorphism
                    Limit". It allows the user to select a new maximum order of
                    endomorphism to replace the default of 2
*/

//import statements
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.beans.*;

public class EndomorphismFrame extends JInternalFrame {

  Category c = new Category();
//  CategoryList l = new CategoryList();
//  int check_enter = 0;

  //Objects in the Graphical User Interface(GUI)
  JButton exit = new JButton();
  JPanel button_panel = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JButton okButton = new JButton();
  JButton cancelButton = new JButton();
  ButtonGroup orderGroup = new ButtonGroup();
  JRadioButton orderOne = new JRadioButton("Order 10", false);
  JRadioButton orderOther = new JRadioButton("Order = ", false);
  JRadioButton orderTwo = new JRadioButton("Order 20", false);
  JRadioButton orderThree = new JRadioButton("Order 30", false);
  JTextField orderField = new JTextField(5);
//  MainWindow2 ed;
  JRadioButton orderFour = new JRadioButton("Order 40", false);
  JRadioButton orderFive = new JRadioButton("Order 50", false);
  JLabel label1 = new JLabel();
//  JLabel label2 = new JLabel();
//  JLabel titleLabel = new JLabel();
//  GBConstraintsEditor g = new GBConstraintsEditor();
	IniSettings ini_;

  public EndomorphismFrame(IniSettings ini)
  {
		ini_ = ini;
	    this.setTitle("Max Endomorphism Order");
	    this.setBackground(new Color(192,192,192));
	    //this.setSize(new Dimension(260, 300));
	    okButton.setLabel("OK");
	
	    okButton.addActionListener(new java.awt.event.ActionListener() {
	      public void actionPerformed(ActionEvent e) {
	        okButton_actionPerformed(e);
	      }
	    });
	    cancelButton.setLabel("Cancel");
	    orderField.setBackground(Color.white);
	    cancelButton.addActionListener(new java.awt.event.ActionListener() {
	      public void actionPerformed(ActionEvent e) {
	        cancelButton_actionPerformed(e);
	      }
	    });
//	    label1.setText("Current Order: " + ini.getMaxLoop());
	    label1.setText("Endomorphism Order:");
//	    titleLabel.setText("Max Order of Endomorphism:");
		orderGroup.add(orderOne);
		orderGroup.add(orderTwo);
		orderGroup.add(orderThree);
		orderGroup.add(orderFour);
		orderGroup.add(orderFive);
		orderGroup.add(orderOther);


		Container contentPane = getContentPane();
		contentPane.setLayout(new GridBagLayout());
		contentPane.add(okButton, new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0
			,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(7, 7, 7, 7), 7, 7));
	    contentPane.add(cancelButton, new GridBagConstraints(1, 6, 1, 1, 0.0, 0.0
	        ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(7, 7, 7, 7), 7, 7));
//	    contentPane.add(titleLabel, new GridBagConstraints(0, 0, 5, 1, 0.0, 0.0
//	        ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
//	    contentPane.add(label1, new GridBagConstraints(0, 0, 1, 0, 0.0, 0.0
//	        ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(7, 7, 7, 7), 7, 7));
//	    contentPane.add(label2, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
//	        ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 10, 0, 0), 0, 0));
	    contentPane.add(orderOne, new GridBagConstraints(0, 0, 2, 1, 0.0, 0.0
	        ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(7, 7, 7, 7), 7, 7));
	    contentPane.add(orderTwo, new GridBagConstraints(0, 1, 2, 1, 0.0, 0.0
	        ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(7, 7, 7, 7), 7, 7));
	    contentPane.add(orderThree, new GridBagConstraints(0, 2, 2, 1, 0.0, 0.0
	        ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(7, 7, 7, 7), 7, 7));
	    contentPane.add(orderFour, new GridBagConstraints(0, 3, 2, 1, 0.0, 0.0
	        ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(7, 7, 7, 7), 7, 7));
	    contentPane.add(orderFive, new GridBagConstraints(0, 4, 2, 1, 0.0, 0.0
	        ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(7, 7, 7, 7), 7, 7));
	    contentPane.add(orderOther, new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
	        ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(7, 7, 7, 7), 7, 7));
	    contentPane.add(orderField, new GridBagConstraints(1, 5, 2, 1, 1.0, 0.0
	        ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(7, 7, 7, 7), 7, 7));
	    selectTrueBox();
	}

  private void selectTrueBox()
  //Determines which check box is true when window is opened
  {
    if (ini_.getMaxLoop() == 10)
      orderOne.setSelected(true);
    else if (ini_.getMaxLoop() == 20)
      orderTwo.setSelected(true);
    else if (ini_.getMaxLoop() == 30)
      orderThree.setSelected(true);
    else if (ini_.getMaxLoop() == 40)
      orderFour.setSelected(true);
    else if (ini_.getMaxLoop() == 50)
      orderFive.setSelected(true);
    else
    {
      orderOther.setSelected(true);
      orderField.setText("" + ini_.getMaxLoop());
    }
  }

  private void okButton_actionPerformed(ActionEvent e)
  //Function called when OK button is pressed
  {
    if (orderOne.isSelected())
      ini_.setMaxLoop(10);
    else if(orderTwo.isSelected())
      ini_.setMaxLoop(20);
    else if(orderThree.isSelected())
      ini_.setMaxLoop(30);
    else if(orderFour.isSelected())
      ini_.setMaxLoop(40);
    else if(orderFive.isSelected())
      ini_.setMaxLoop(50);
    else if (orderOther.isSelected())
    {
      try
      {
        ini_.setMaxLoop(Integer.parseInt(orderField.getText()));
      }
      catch (NumberFormatException e1)
      {
        System.out.println("Error. Endomorphism value must be an integer");
      }
    }
	try {this.setClosed(true);}
	catch (PropertyVetoException PVE) {}
}

  private void cancelButton_actionPerformed(ActionEvent e)
  {
	try {this.setClosed(true);}
	catch (PropertyVetoException PVE) {}
  }
}