import javax.swing.JOptionPane;


public class InputCheck
{
	//Special words that are not allowed to be inputed by the user
	private String specialStrings[] = {"category", "objects", "arrows", "relations", "functor", "gml"};
	//Special characters that are not allowed to appear anywhere in a user
	//entered string of text
	private char specialChars[] = {'*', '#', '.', ',', ' ', ':', '-', '>', '(', ')', '='};


	public InputCheck()
	{ // uses default special strings and characters
	}

	public InputCheck(String[] specialStrings_, char[] specialChars_)
	{
		specialStrings = specialStrings_;
		specialChars = specialChars_;
	}
	
	
	public boolean checkStrings(String text)
	//This method checks the string text to determine if it is the same as any of
	//strings defined as special strings. It returns true if string is ok and false
	//if string contains one of the special strings
	{
		text = text.toLowerCase();
		for (int i=0; i<specialStrings.length; i++)
		{
			if (text.equals(specialStrings[i]))
			{
				JOptionPane.showMessageDialog(null, text + " is a special word and can not be used.", "Error", JOptionPane.ERROR_MESSAGE);
//				new MessageDialog(this, "Error", text + " is a special word and can not be used.", true);
				return false;
			}
		}
		return true;
	}

	public boolean checkChars(String text)
	//This method checks the string text to determine if it it contains any
	//of the special characters defined above. It returns true if string is
	//ok and false if string contains one of the special characters
	{
		for (int i=0; i<specialChars.length; i++)
		{
			for (int j=0; j<text.length(); j++)
			{
				if (text.charAt(j) == specialChars[i])
				{
/*					if ((specialChars[i] == '*') && (menuoption == 1) && ((submenu == 5) || (submenu == 6)))
					{
					}
					else if ((specialChars[i] == '*') && (menuoption == 2) && (submenu == 3))
					{
					}
					else
					{*/
						JOptionPane.showMessageDialog(null, text + " contains the special character \"" + text.charAt(j) + "\" and can not be used.", "Error", JOptionPane.ERROR_MESSAGE);
						//new MessageDialog(this, "Error", text + " contains the special character " + text.charAt(j) + " and can not be used.", true);
						return false;
//					}
				}
			}
		}
		return true;
	}

	public boolean check(String text)
	//Check string for special words and characters
	{
		return (checkStrings(text) && checkChars(text));
	}
}