
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class LimitFrame extends JInternalFrame
{	
	boolean endopassed = false;

	JLabel LLabel = new JLabel("L Object:");
	JTextField LField = new JTextField(13);
	JTextField[] lambdaFields;
	FunctorNode functor_;
	JButton limitButton = new JButton("Limit?");	
	
	FunctorInternalFrame functorInternalFrame_;
	
	public LimitFrame(FunctorInternalFrame functorInternalFrame)
	{
		super(functorInternalFrame.getTitle() + ": Limit Tool", true, true, false, false);
		functorInternalFrame_ = functorInternalFrame;		
		functor_ = functorInternalFrame_.getFunctor();

		lambdaFields = new JTextField[functor_.A.num_objects];

		limitButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				limitButton_action();
			}
		});



		getContentPane().setLayout(new GridBagLayout());
		getContentPane().add(LLabel, new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0
		,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(3, 3, 3, 3), 0, 0));
		getContentPane().add(LField, new GridBagConstraints(1, 0, 1, 1, 1.0, 1.0
		,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(3, 3, 3, 3), 0, 0));
	
	
		// there will be (functor_.A.num_objects) paths; make an array of textfields for this.
		int i;
		for (i=0; i<lambdaFields.length; i++)
			createObjectLabelAndField(functor_.B.obj[functor_.f.obj[i]], i+1);


		getContentPane().add(limitButton, new GridBagConstraints(0, i+1, 2, 1, 1.0, 1.0
		,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(3, 3, 3, 3), 0, 0));		
	}
	
	private void createObjectLabelAndField(String objectName, int row)
	{
		getContentPane().add(new JLabel("Path to: " + objectName), new GridBagConstraints(0, row, 1, 1, 1.0, 1.0
		,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(3, 3, 3, 3), 0, 0));
		getContentPane().add((lambdaFields[row-1] = new JTextField(13)), new GridBagConstraints(1, row, 1, 1, 1.0, 1.0
		,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(3, 3, 3, 3), 0, 0));
	}
	
	private void limitButton_action()
	{
		String output = "";
		String LObject = LField.getText();
		int lObject = -99;
		int[] id = new int[2];
		id[0] = -2;
		id[1] = -1;
		int[][] lambdaPaths = new int[lambdaFields.length][0];	// 0 doesn't mean anything; this will be replaced at
																	// each step by a path of a specific length;
																	// they'll all be different, and will not waste space

/*	1. first check that "L" is in B; then check that each path
		a. is in B
		b. has domain L
		c. has codomain "the object listed in the label"
	2. for every arrow in delta (domain category), make sure  the triangle
	                        F(domain)-->F(codomain)
	                            \----<L>---/
	   commutes.
	3. Make a new cone; add the cone to list



*/


	//	int[] lambdaPaths = new int[lambdaFields.length];

		if (functor_.B.check_obj(LObject))
		{	
			lObject = functor_.B.object_number(LObject);
			for (int i=0; i<lambdaFields.length; i++) // loop through all paths; check each one for properties (?)
			{
				// check that the path goes from "L" to functor_.B.obj[functor_.f.obj[i]]
				if (functor_.B.check_string(lambdaFields[i].getText()))
				{
					lambdaPaths[i] = functor_.B.string_to_path(lambdaFields[i].getText());
					if (functor_.B.check_path(lambdaPaths[i]))
					{
// if identity is a lambdapath, this crashes;
// for the identity to be a lambdapath, then 'i' must equal the lObject i think
if (lambdaPaths[i][0] == -1) System.out.println("this is -1: " + i);
						if (lambdaPaths[i][0] == -2 || lambdaPaths[i][0] == -1)
						{
							if (functor_.f.obj[i] != lObject)
							{
								output+="For the ith lambda to be an identity, the ith object must be the same as the limit object.\n"
									+ functor_.f.obj[i] + " != " + lObject;
							}
						}
		// check somewhere to find out if any lambdaPaths are -1...check error on other monitor
						else
						{
							if (functor_.B.arr[lambdaPaths[i][functor_.B.path_len(lambdaPaths[i])-1]][0] != lObject)
							{
								output+="Domain of " + lambdaFields[i].getText() + " must equal " + LObject + ".\n";
							}
							if (functor_.B.arr[lambdaPaths[i][0]][1] != functor_.f.obj[i])
							{
								output+="Codomain of " + lambdaFields[i].getText() + " must equal " + functor_.B.obj[functor_.f.obj[i]] + ".\n";
							}
						}
					}
					else
					{
						output+="Invalid path: " + lambdaFields[i].getText() + ".\n";
					}
				}
				else
				{
					output+="Invalid path: " + lambdaFields[i].getText() + ".\n";
				}
			}
		}
		else
		{
			output+=LObject + " is not an object of " + functor_.B.name + ".\n";
		}
		
		if (output.equals(""))
		{
			for (int i=0; i<functor_.A.num_arrows; i++)
			{
				int[] ga = functor_.f.arr[i]; // this is path F(alpha).
// we can find the co/domain of the identity: f.arr[i] relates to A.arr[i], so the co/domain of the identity
// is F(domain of A.arr[i]) also equal to F(codomain of A.arr[i])

// then what?

// not really sure this does anything at all (or is supposed to do anything)
//System.out.println(functor_.B.path_to_string(ga));
				int[] lambdaIThenGammaAlpha = new int[0];
				int[] lambdaJ = new int[0];
				// find the path specified by the user that goes from
				// the "L" object to the domain of 'ga'.
				
				// loop through lambaPaths; 
				for (int j=0; j<lambdaPaths.length; j++)
				{
					int codomainLambdaPathJ = (lambdaPaths[j][0] == -1 || lambdaPaths[j][0] == -2) ? lObject : functor_.B.arr[lambdaPaths[j][0]][1];				
					
					if (functor_.B.path_len(ga) == 0)
					{
						if (codomainLambdaPathJ == functor_.f.obj[functor_.A.arr[i][0]])
						{
							// we just have to check that lambda(I) is equal to lambda(J)
							// same thing as the one below, except without appending ga
							lambdaIThenGammaAlpha = lambdaPaths[i];
							lambdaJ = lambdaPaths[j];
						}							
					}
					else
					{
						if (codomainLambdaPathJ // codomain of lambda(j)
						== functor_.B.arr[ga[functor_.B.path_len(ga)-1]][0]) // domain of F(alpha)
						{
							System.out.println("equals the domain");
							lambdaIThenGammaAlpha = functor_.B.append_path(lambdaPaths[i], ga);
						}
						if (codomainLambdaPathJ // codomain of lambda(j)
						== functor_.B.arr[ga[0]][1])
						{
							System.out.println(functor_.B.arr[ga[0]][1]);
							System.out.println("equals the co?domain");
							lambdaJ = lambdaPaths[j];
						}
					}
				}
				// now check equality
				if (lambdaIThenGammaAlpha.length == 0 || lambdaJ.length == 0)
				{
					System.out.println("no length");
					// no length? can't find the things?
				}
				else if (functor_.B.equals(functor_.B.reduce(lambdaIThenGammaAlpha), functor_.B.reduce(lambdaJ)))
				{
//					System.out.println(functor_.B.path_to_string(lambdaIThenGammaAlpha) + " = " + functor_.B.path_to_string(lambdaJ));
//					System.out.println("above commutes");
				}
				else //if (!functor_.B.equals(lambdaIThenGammaAlpha, lambdaJ))
				{
					System.out.println("Paths do not specify a cone:\n" + functor_.B.path_to_string(lambdaIThenGammaAlpha) + " != " + functor_.B.path_to_string(lambdaJ));
					JOptionPane.showInternalMessageDialog(functorInternalFrame_, "Paths do not specify a cone:\n" + functor_.B.path_to_string(lambdaIThenGammaAlpha) + " != " + functor_.B.path_to_string(lambdaJ), "Error", JOptionPane.ERROR_MESSAGE);
					return;
				}
			}
			
			// check all other cones now...1-1, onto things
			// i think lambdaPaths actually is a cone; depending on how it is indexed
			// make a cone!
			// call limit function
	
			ConeNode lambda = new ConeNode(lambdaPaths, lObject, functor_.B);

////// generate all other cones; 
			// loop on T (number of T will be i); find all cones;
			for (int i=0; i<functor_.B.num_objects; i++)
			{
				// do something if T(i) == L; need to manually add the identity as a gamma
				// also do something if any of the specified paths are identities
				ConeList listOfConeTgammas = new ConeList(); // listOfConeTgammas is built inside coneBuilder()
				ConeList imageHomTL = new ConeList(); // not sure what the difference is; imageHomTL is built inside check_oneone
				HomTree homTL = new HomTree();
				HomTree homTlambdaLast = new HomTree();
				int[][] coneTgammaI = new int[functor_.A.num_objects][0];
				HomTree[] homTtoDeltaI = new HomTree[functor_.A.num_objects];
				int[] numArrowsHomTtoDeltaI = new int[functor_.A.num_objects];
				// could be sketchy...
				// take all homtrees from T-->(objects F(delta))
				// take each combination of paths from homtrees...call isCone() function (?)
				for (int j=0; j<functor_.A.num_objects; j++)
				{
					//HomTree pathTree = new HomTree();
					int[] path = new int[functor_.B.ini.getMAXWORD()];
					path[0] = -1;
					homTtoDeltaI[j] = new HomTree();
					numArrowsHomTtoDeltaI[j] = functor_.B.makeHomTree(path, homTtoDeltaI[j], i, functor_.f.obj[j], functor_.B.ini.getMaxLoop(), new HomTree());
				}
//		System.out.println("does this");		
				// now take each combination of paths from homtrees, and make it into a path
				coneBuilder(i, listOfConeTgammas, coneTgammaI, homTtoDeltaI, numArrowsHomTtoDeltaI, 0);
//		System.out.println("but does it do this?");		
				
				// now we have a list of cones from T to gamma.
				// find a bijection from homTL --> coneTgammas
				// or, find a unique little gamma:T-->L, such that for all I, lambda(I)*littlegamma = tau(I)
				// so now we check 1-1 and check onto.
				
				int[] gamma = new int[functor_.B.ini.getMAXWORD()];
				gamma[0] = -1;
				// listOfConeTgammas is not the same as imageHomTL (i don't think)
//				y=0; x=0;
//System.out.println("obj: " + functor_.B.obj[i]);
				if (i == lObject)
					homTL.addPath(id);
				if (!check_oneone(gamma, i, i, lObject, imageHomTL, lambda, homTL, functor_.B.ini.getMaxLoop(), new HomTree()))
				{
					output+="Problem at object " + functor_.B.obj[i] + ". Not 1-1: not a limit.";
//		System.out.println("O: " + output);		
				
					JOptionPane.showInternalMessageDialog(functorInternalFrame_, output, "Error", JOptionPane.ERROR_MESSAGE);
					return;
				}
				else
				{
					int[] path = new int[functor_.B.ini.getMAXWORD()];
					path[0] = -1;
					functor_.B.makeHomTree(path, homTlambdaLast, i, functor_.f.obj[functor_.A.num_objects-1], functor_.B.ini.getMaxLoop(), new HomTree());
					if (i == functor_.f.obj[functor_.A.num_objects-1])
						homTlambdaLast.addPath(id);
					path[0] = -1;
					// now check onto
					if (homTlambdaLast.root.down != null && !check_onto(new int[functor_.A.num_objects][0], path, lambda, i, i, 0, imageHomTL, homTlambdaLast, functor_.B.ini.getMaxLoop(), new HomTree()))
					{
						output+="Problem at object " + functor_.B.obj[i] + ". Not onto: not a limit.";
//			System.out.println("O: " + output);		
						JOptionPane.showInternalMessageDialog(functorInternalFrame_, output, "Error", JOptionPane.ERROR_MESSAGE);
						return;
					}
				}
			}
			JOptionPane.showInternalMessageDialog(functorInternalFrame_, LObject + " is a limit.", "Limit", JOptionPane.INFORMATION_MESSAGE);
		}
		else
		{
			JOptionPane.showInternalMessageDialog(functorInternalFrame_, output, "Error", JOptionPane.ERROR_MESSAGE);
		}
		
					
	//			System.out.println(lambdaFields[i].getText());
	}
	
	
	private void coneBuilder(int domain, ConeList listOfConeTgammas, int[][] coneTgammaI, HomTree[] homTtoDeltaI, int[] numArrowsHomTtoDeltaI, int object)
	{
		if (object >= functor_.A.num_objects)
		{
//		System.out.println("does it ever do this");
			// end of this function;
			// add the cone to the thingy; rather, test it, then add it
			if (testCone(coneTgammaI, domain))
			{//System.out.println("testing cone");
//				(new ConeNode(coneTgammaI, domain, functor_.B)).printCone();
				// add the cone to the list, somehow
//				ConeNode
				listOfConeTgammas.insertCone(new ConeNode(coneTgammaI, domain, functor_.B));
			}
			return;
		}
		
		int[] lambdaI = homTtoDeltaI[object].getFirstPath();
		System.out.println("new loop:");
		for (int i=0; i<numArrowsHomTtoDeltaI[object]; i++)
		{
			// add the path to the cone...
			coneTgammaI[object] = functor_.B.reduce(lambdaI);
			System.out.println("LI: " + functor_.B.path_to_string(coneTgammaI[object]));
			coneBuilder(domain, listOfConeTgammas, coneTgammaI, homTtoDeltaI, numArrowsHomTtoDeltaI, object+1);
			// remove something somehow?
			lambdaI = homTtoDeltaI[object].getNextPath();
		}
		// object starts at 0
		// for (int i=0; i<homTree.getNumPaths(); i++)
		//	coneBuilder(coneTgammaI, 1);
		// ending condition: object >= functor_.A.num_objects;
	}
	
	private boolean testCone(int[][] testCone, int domain)
	{
// testCone should contain paths that are already reduced; check this!
//System.out.println("new cone");
		for (int i=0; i<functor_.A.num_arrows; i++)
		{
			int[] ga = functor_.f.arr[i]; // this is path F(alpha).
			int[] lambdaIThenGammaAlpha = new int[0];
			int[] lambdaJ = new int[0];
			// find the path specified by the user that goes from
			// the "L" object to the domain of 'ga'.
			
			// loop through testCone 
//System.out.println("same cone");
			for (int j=0; j<testCone.length; j++)
			{
//System.out.println(j + ": " + functor_.B.path_to_string(testCone[j]));
//System.out.println(testCone[j][0]);
				int codomainTestConeJ = (testCone[j][0] == -2 || testCone[j][0] == -1) ? domain : functor_.B.arr[testCone[j][0]][1];
//				{
//					codomainTestConeJ = domain;// actually just the domain of every path in testCone; the T object
//				}

				if (functor_.B.path_len(ga) == 0)
				{
					lambdaIThenGammaAlpha = testCone[i];
					lambdaJ = testCone[j];
				}
				else
				{
					if (codomainTestConeJ // codomain of lambda(i) // becomes -2 in error; since it's an identity
	// maybe just add in a special case for identities
					== functor_.B.arr[ga[functor_.B.path_len(ga)-1]][0]) // domain of F(alpha)
					{
						lambdaIThenGammaAlpha = functor_.B.append_path(testCone[i], ga);
					}
					if (codomainTestConeJ // codomain of lambda(i)
					== functor_.B.arr[ga[0]][1])
					{
						lambdaJ = testCone[j];
					}
				}
			}
				lambdaIThenGammaAlpha = functor_.B.reduce(lambdaIThenGammaAlpha);
				lambdaJ = functor_.B.reduce(lambdaJ);		
				
//		System.out.println("LI: " + functor_.B.path_to_string(lambdaIThenGammaAlpha) + " LJ: " + functor_.B.path_to_string(lambdaJ));
			
			// now check equality
			if (lambdaIThenGammaAlpha.length == 0 || lambdaJ.length == 0)
			{
				System.out.println("no length");
				// no length? none can't find the thingies?
			}
			if (functor_.B.equals(lambdaIThenGammaAlpha, lambdaJ))	{}
			else{System.out.println("clearly false");
				return false;}
		}
//		System.out.println("is this true?");
		return true;
	}
	
	
	
	
	
// fix whatever's broken	
	
	
	
	
	
	
	
	
	
	private boolean check_oneone(int gamma[], int origDomain, int domain, int codomain, ConeList imageHomTL, ConeNode lambdaCone, HomTree homTL, int maxloop, HomTree pathtree)
	/*
	Parameters:
	        gamma:      the current path (trying to go from T-->L)
	        origDomain: the original domain (T)
	        domain:    the current object of the path
	        codomain:  the object we are trying to find all arrows to (L, the limit object)
	        objects:   an array of integers which keeps the function from exceeding
	                      the maximum number of loops
	        imageHomTL:  a tree returned with all gamma-lambdas
	        homTL: the tree of all arrows to limit object from domain
	        maxloop :  endomorphism limit
	
	 Purpose:
	        To generate the reduced hom set from T to L and check that the limit object (L)
	        is one-to-one (injective);
	
	 Design:
	        Creates a tree imageHomTL containing the reduced form
	        of all the gamma-lambdaIs. Also creates a tree homTL with all
	        the gamma paths.
	*/
	{
		int len = 0; // length of the gamma path
		int number = 0; // the number of arrows from the current domain
		int codom, endo = 0; // codom is the current codomain of gamma
		int arrow_array[] = new int[functor_.B.num_arrows];	// stores all of the arrows from the current domain
		int[][] reducedGammaLambdaI = new int[functor_.A.num_objects][0];
//System.out.println(x++);
	
		gamma = functor_.B.reduce(gamma);	// make sure the current path (gamma) is reduced
		len = functor_.B.path_len(gamma);	// store the length of gamma in 'len'
		if (gamma[0] == -2)			// if gamma is the identity arrow
			gamma[0] = -1;			// set it to be an empty path
		
		/* check all of the arrows in the gamma path; if any of the codomains of
		 * the arrows are equal to the domain of the first arrow (i.e. the start of the path),
		 * increment endo; if the starting domain is found on too many of the arrows,
		 * we will not perform the algorithm 
		 */
		for (int i=0; i<len; i++)
			if (functor_.B.arr[gamma[i]][1] == functor_.B.arr[gamma[len-1]][0])
				endo++;	// increment endo by 1
	
		if (endo < maxloop && len < functor_.B.ini.getMAXWORD()-1)	// if the path is too long, or endo is too large (see above)
		{															// we won't perform the algorithm
			if (!pathtree.containsPath(gamma) || len == 0)	// if we haven't encountered the path before (or the length is 0)
			{
//System.out.println("found path");
				if (len == 0)		// if gamma is an empty path, set codom to be -1
					codom = -1;
				else
				{
					pathtree.addPath(gamma);	// add gamma to the pathtree; makes sure we don't take the same path twice
					codom = functor_.B.arr[gamma[0]][1];	// the codomain of the last arrow in the path
				}
				if (codom == codomain)  // if the codomain of the last arrow in the path is the limit(?) object
				{
//System.out.println("found codomain");
					int newgamma[] = functor_.B.reduce(gamma);	// reduce the gamma (which we have already done); seems redundant
					if (homTL.addPath(newgamma))				// if the path is not in homTP, add it and continue; if it already is, skip "if"
					{
//System.out.println("added new gamma");

						for (int i=0; i<reducedGammaLambdaI.length; i++)
						{
							reducedGammaLambdaI[i] = functor_.B.reduce(functor_.B.append_path(gamma, lambdaCone.getCone()[i]));
						}

						for (int i=0; i<reducedGammaLambdaI.length; i++)
						{
							if (functor_.B.path_len(reducedGammaLambdaI[i]) == 0)	// if lambda*gamma is empty, set it to be the identity arrow
							{
								reducedGammaLambdaI[i][0] = -2;
								reducedGammaLambdaI[i][1] = -1;
							}
						}

// turn imageHomTL into a list of cones; the cone is already defined as "reducedGammaLambdaI"
						if (!imageHomTL.insertCone(new ConeNode(reducedGammaLambdaI, origDomain, functor_.B))) // we have to worry about addresses/references
						{
							System.out.println("line 478 returns false with domain: " + origDomain);// + " and reduced GammaLambdaI: " + functor_.B.path_to_string(reducedGammaLambdaI));
							return false;
						}
					}
				}
//System.out.println("keep generating...curr path: " + functor_.B.path_to_string(gamma));

				number = functor_.B.all_arr(domain, arrow_array);	// all arrows from the domain are now stored in arrow_array
				for (int i=0; i<number; i++)	// loop through all arrows from the domain
				{
					domain = functor_.B.arr[arrow_array[i]][1];	// now set domain to be the codomain of the ith arrow
					for (int j=len; j>=0; j--)
						gamma[j+1] = gamma[j];	// add the ith arrow to the path
					gamma[0] = arrow_array[i];
					// then check all arrows from the object recursively.
					if (!check_oneone(gamma, origDomain, domain, codomain, imageHomTL, lambdaCone, homTL, maxloop, pathtree))
					{System.out.println("line 487 returns false with original/domain: " + origDomain + "/" + domain + " and gamma: " + functor_.B.path_to_string(gamma));
						return false;}	// if one of these checks returns false, the entire thing is false (i.e. not one-to-one)
	
					len = functor_.B.path_len(gamma);	// store the new length of the current path (gamma)
					for (int j=0; j<len; j++)	
						gamma[j] = gamma[j+1];	// remove that arrow from the path; then loops around to check the next arrow
				}								// like a depth first search of a graph
				//return true;	// return true if all of these checks have returned true
			}
		}
		else
		{
			endopassed = true;	// otherwise set endopassed to be true; we have encountered too many loops in the path\
			return false;
		}
		return true;
	}
	
	private boolean check_onto(int[][] tToLambda, int[] delta, ConeNode lambdaCone, int origDomain, int domain, int indexOfCodomain, ConeList imageHomTL, HomTree homTlambdaLast, int maxloop, HomTree pathtree)
	/*
	Parameters:
	        tToLambda: the current paths (from T-->lambda[0 to n-2])
            lambdaCone: the paths from L-->lambdaI
            origDomain: the original domain (T); needed to construct the cones
	        domain: the current object of the path (starts out as T)
	        indexOfCodomain:the index (in functor_.f.obj[]) of the object we are trying to find all arrows to;
	                        will include all objects of functor_.f.obj[]
	        maxloop: an integer that keeps the function from exceeding
	                 the maximum number of loops
	        imageHomTL: the list of lambdaI cones;
	        homTlambdaLast:    a tree of all the rhos (paths from T-->lastLambda)
	Local Variables:
	        number: stores the number of arrows from an object
	        current_arrow:  stores the number of the current arrow in the path
	        codom:  stores the codomain of the current arrow
	        arrow_array:    contains all of the arrows from the last object on the path
	Purpose:
	        To check that a limit cone is onto; (something else:) i.e. for every delta such that alpha*delta = beta*epsilon,
	        the pair <delta, epsilon> is already in imageHomTP.
	Design:
	        Generates all of the deltas from one object to another and uses homTB tree
	        it is passed to check that all of the pairs <delta, epsilon> are in imageHomTP.
	*/
	{
//		System.out.println("how many times");
//		int i, j = 0; // i and j are used in for...loops
		int len = 0; // length of the gamma path
		int number = 0; // the number of arrows from the current domain
		int codomain; // codomain is the current domain that we are trying to get to
		int codom, endo = 0; // codom is the current codomain of gamma; endo is the number of times the domain object occurs in the path
		int arrow_array[] = new int[functor_.B.num_arrows];	// stores all of the arrows from the current domain
		delta = functor_.B.reduce(delta);	// make sure the current path (gamma) is reduced
		if (delta[0] == -2)			// if delta is the identity arrow
			delta[0] = -1;			// set it to be an empty path
		len = functor_.B.path_len(delta);
		codomain = functor_.f.obj[indexOfCodomain];
//System.out.println(y++ + " : " + functor_.B.obj[domain] + " : " + functor_.B.path_to_string(delta) + " : " + functor_.B.obj[codomain]);
	
// i think what we have to do is generate all lambdas(0 to n-2) for n objects in A; then
// loop through all paths from T-->lambda(n-1), and if they make a cone, check to see that
// the cone is in imageHomTL...	
// when the path to the first one is found, increment codomain (rather, functor_.f.obj[i++], and do it again
// stop when we're on the last object of functor_.A.obj[]; we'll have to change codomain to the index of the thingy

		/* check all of the arrows in the delta path; if any of the codomains of
		 * the arrows are equal to the domain of the first arrow (i.e. the start of the path),
		 * increment endo; if the starting domain is found on too many of the arrows,
		 * we will not perform the algorithm 
		 */
		for (int i=0; i<len; i++)
			if (functor_.B.arr[delta[i]][1] == functor_.B.arr[delta[len-1]][0])
				endo++;
	
		if (endo < maxloop && len < functor_.B.ini.getMAXWORD()-1)// if the path is too long, or endo is too large (see above)
		{															// we won't perform the algorithm
			if (!pathtree.containsPath(delta) || len == 0)	// if we haven't encountered the path before (or the length is 0)
			{
				if (len == 0)	// if delta is an empty path, set codom to be the domain (i.e. it's now an identity arrow)
					codom = domain;
				else
				{
					pathtree.addPath(delta);	// add delta to the pathtree; makes sure we don't take the same path twice
					codom = functor_.B.arr[delta[0]][1];		// sets codom to be the codomain of the last arrow in the path
				}
				if (codom == codomain)	// if the codomain of the last arrow in the path is the codomain we're looking for
				{
					if (delta[0] == -1)	// if delta is an empty path, set it to be an identity arrow
					{
						delta[0] = -2;
						delta[1] = -1;
					}

//System.out.println("oioadads: " + functor_.B.obj[codomain]);
					tToLambda[indexOfCodomain] = delta;
					// if we have more paths to find, put this path into the cone, and call check_onto(..., codomain+1,...);
					if (indexOfCodomain == /*functor_.f.obj[*/ functor_.A.num_objects-2)
					{
						// we are done generating: now check
//					System.out.println("and this");
//System.out.println("delta: " + functor_.B.path_to_string(delta));
					
					
						// if we are at the second to last path (codomain == functor_.f.obj[functor_.A.num_objects-2])
						// then we have to loop through all the homTlastLambda paths, testing each with the generated cone
						// to see if anyone of them makes a cone; if one does, check to make sure it is already in the imageHomTL tree/cone
						
						
						//int[] newdelta = functor_.B.reduce(delta); // reduce the delta (which we have already done); seems redundant
						// we have delta generated; now loop through all epsilons, checking for commutativity with alpha and beta;
						// if any do commute, then check to see the pair <delta, epsilon> is in imageHomTP
						int[] epsilon = new int[0];	// construct epsilon path
						epsilon = homTlambdaLast.getFirstPath();	// set epsilon path to be the first path in the homTB tree
	
						for (int j=0; j<homTlambdaLast.getLength(); j++)	// loop on the number of paths in the homTB tree
						{
//System.out.println("ep: " + functor_.B.path_to_string(epsilon));
							tToLambda[functor_.A.num_objects-1] = epsilon;
for (int h=0; h<tToLambda.length; h++)
{
//	if (tToLambda[h].length != 0)
//		System.out.println("h " + h + ": " + functor_.B.path_to_string(tToLambda[h]));
}
							if (testCone(tToLambda, origDomain))
							{
								// now check to see that it is in the imageHomTL
								if (!imageHomTL.searchFor(new ConeNode(tToLambda, origDomain, functor_.B)))
								{
									System.out.println("it was not found");
									return false; // the generated cone was not found in imageHomTL
									// do something...or nothing; maybe do something if false
								}
							}
							epsilon = homTlambdaLast.getNextPath();	// check the next epsilon in the homTB tree
						}
					}
					else
					{ //System.out.println(functor_.B.path_to_string(delta));
						int[] nextDelta = new int[functor_.A.ini.getMAXWORD()];
//						int firstDomain;
//						if (delta[0] == -2)
//							firstDomain = domain;
//						else
//							firstDomain = functor_.B.arr[delta[functor_.B.path_len(delta)-1]][0];
//y=0;
						nextDelta[0] = -1;
						if (!check_onto(tToLambda, nextDelta, lambdaCone, origDomain, origDomain, indexOfCodomain+1, imageHomTL, homTlambdaLast, maxloop, new HomTree()))
							return false; // if we don't want to do anything else, then we just return the not (!) result of the check_onto call
					}
					// not sure yet
				}
				if (delta[0] == -2) delta[0] = -1;	// if delta is an identity arrow, set it to be an empty path
	
				number = functor_.B.all_arr(domain, arrow_array);	// store all arrows from the current domain in arrow_array
				if (number > 0)
					for (int i=0; i<number; i++)			// loop through all arrows from domain
					{									// reset domain to be the codomain of the first arrow from
						domain = functor_.B.arr[arrow_array[i]][1];// the original domain
						for (int j=len; j>=0; j--)					
							delta[j+1] = delta[j];			// add the new arrow to the path
						delta[0] = arrow_array[i];

						// recursively check all paths; like a depth-first search
						if (!check_onto(tToLambda, delta, lambdaCone, origDomain, domain, indexOfCodomain, imageHomTL, homTlambdaLast, maxloop, pathtree))
							return false;	// if any of the checks return false, it is not onto
			
						for (int j=0; j<=len; j++)
							delta[j] = delta[j+1];	// remove the newest arrow from the path; "pop" it
					}
			}
		}
		else
		{ 
			endopassed = true;	// set endopassed to be true, and return false; not sure why...check_oneone doesn't return false in this case
			return false;
		}
		return true;
	}

}