import javax.swing.JInternalFrame;
import javax.swing.JOptionPane;

public class ProductCategory
{
	private CategoryInternalFrame categoryInternalFrame_;
	private Category A;
	private Category B;
	private Category product_;

	public ProductCategory(CategoryInternalFrame categoryInternalFrame)
	{
		categoryInternalFrame_ = categoryInternalFrame;
	}
	
	public void createProductCategory()
	{
		int framecount =0;
		JInternalFrame[] jifs = categoryInternalFrame_.getDesktopPane().getAllFrames();
		for (int i=0; i<jifs.length; i++)
		{
			if (jifs[i] instanceof CategoryInternalFrame)
				framecount++;
		}
		Category[] categories = new Category[framecount];
		framecount=0;
		for (int i=0; i<jifs.length; i++)
		{
			if (jifs[i] instanceof CategoryInternalFrame)
				categories[framecount++] = ((CategoryInternalFrame)jifs[i]).getCategory();
		}

		A = new Category();
		B = new Category();
		Category temp = (Category)JOptionPane.showInputDialog(categoryInternalFrame_, "Choose another category:", "Product of Categories", JOptionPane.QUESTION_MESSAGE, null, categories, categories[0]);
		product_ = new Category();
		
		if (temp == null)
			return;
		else 
			B.copyCategory(temp);

		A.copyCategory(categoryInternalFrame_.getCategory());
		
		// create product objects
		setProductObjects();

		// create product arrows
		setProductArrows();
				
		// create type 1 product relations; type (ln,1)...(l1, 1) = (rn, 1)...(r1, 1), and reverse
		setType1Relations(A, B);
		setType1Relations(B, A);

		// create type 2: (1A`f)(m`1B) = (m`1A)(1B`f), and others
		// these are only for generators, not paths
		setType2Relations();

		product_.comment = A.name + ": " + A.comment + "\n" + B.name + ": " + B.comment;
		product_.name = A.name + "*" + B.name;
		product_.setGML();
		product_.mod.isCreated();
		((MainWindow2)categoryInternalFrame_.getDesktopPane().getParent().getParent().getParent()).createCategoryInternalFrame(product_);
	}

	private void setProductObjects()
	{
		for (int i=0; i<A.num_objects; i++)
		{
			for (int j=0; j<B.num_objects; j++)
			{
				product_.obj[product_.num_objects++] = A.obj[i] + "`" + B.obj[j];
			}
		}
	}

	private void setProductArrows()
	{
		for (int i=0; i<product_.num_objects; i++)
		{
			String[] current_;
			String[] check_;
			current_ = product_.obj[i].split("`");
			for (int j=0; j<product_.num_objects; j++)
			{
				check_ = product_.obj[j].split("`");
				if (current_[0].equals(check_[0]))// && current_[1] != check_[1])
				{
					for (int y=0; y<B.num_arrows; y++)
					{
						if (B.arr[y][0] == B.object_number(current_[1]) && B.arr[y][1] == B.object_number(check_[1]))
						{// then we have combination of arrows from A to B in product_
							product_.arrow[product_.num_arrows] = "(1" + current_[0] + "`" + B.arrow[y] + ")";
							product_.arr[product_.num_arrows][0] = i;
							product_.arr[product_.num_arrows++][1] = j;
						}
					}
				}
				else
				{
					for (int x=0; x<A.num_arrows; x++)
					{
						if (A.arr[x][0] == A.object_number(current_[0]) && A.arr[x][1] == A.object_number(check_[0])) // arrow between curr and check
						{// check corresponding arrow in B category
							if (current_[1].equals(check_[1]))
							{
								product_.arrow[product_.num_arrows] = "(" + A.arrow[x] + "`1" + current_[1] + ")";
								product_.arr[product_.num_arrows][0] = i;
								product_.arr[product_.num_arrows++][1] = j;
							}
/*							else
							{
								for (int y=0; y<B.num_arrows; y++)
								{
									if (B.arr[y][0] == B.object_number(current_[1]) && B.arr[y][1] == B.object_number(check_[1]))
									{// then we have combination of arrows from A to B in product_
										product_.arrow[product_.num_arrows] = "(" + A.arrow[x] + ":" + B.arrow[y] + ")";
										product_.arr[product_.num_arrows][0] = i;
										product_.arr[product_.num_arrows++][1] = j;
									}
								}
							}*/
						}
					}
				}
			}
		}
	}
		

	private void setType1Relations(Category first_, Category second_)
	{
		for (int x=0; x<first_.num_objects; x++)
		{
			for (int i=0; i<second_.num_relations; i++)
			{
				product_.relations[product_.num_relations] = new Relation();
				if (second_.relations[i].lhs[0] == -2) // identity code
				{
					product_.relations[product_.num_relations].lhs[0] = -2;
					product_.relations[product_.num_relations].lhs[1] = -1; // end of path
				}
				else
				{
					for (int j=0; j<second_.path_len(second_.relations[i].lhs); j++)
					{
						product_.relations[product_.num_relations].lhs[j] = product_.arrow_number("(1" + first_.obj[x] + "`" + second_.arrow[second_.relations[i].lhs[j]] + ")");
					}
					product_.relations[product_.num_relations].lhs[second_.path_len(second_.relations[i].lhs)] = -1;
				}
				if (second_.relations[i].rhs[0] == -2) // identity code
				{
					product_.relations[product_.num_relations].rhs[0] = -2;
					product_.relations[product_.num_relations].rhs[1] = -1; // end of path
				}
				else
				{
					for (int k=0; k<second_.path_len(second_.relations[i].rhs); k++)
					{
						product_.relations[product_.num_relations].rhs[k] = product_.arrow_number("(1" + first_.obj[x] + "`" + second_.arrow[second_.relations[i].rhs[k]] + ")");
					}
					product_.relations[product_.num_relations].rhs[second_.path_len(second_.relations[i].rhs)] = -1;
				}
				product_.num_relations++;
			}
		}
	}
	
	private void setType2Relations()
	{
		Relation[] relation_ = new Relation[((MainWindow2)categoryInternalFrame_.getDesktopPane().getParent().getParent().getParent()).getIni().getRELLEN()];
		for (int i=0; i<relation_.length; i++)
			relation_[i] = new Relation();
		int num_total = 0;
		//int num_right = 0;		
		for (int i=0; i<product_.num_arrows; i++)
		{
			String[] current_;
			String[] check_;
			current_ = product_.arrow[i].split("`");
			for (int j=0; j<product_.num_arrows; j++)
			{
				check_ = product_.arrow[j].split("`");
				if (product_.arr[i][1] == product_.arr[j][0])
				{// the codomain of the first is the same as the domain of the second
				 // take every pair of arrows like this, and match them with arrows of the other type
					if (current_[0].startsWith("(1") && check_[1].startsWith("1"))
					{// the first type
						relation_[num_total].lhs[1] = i;
						relation_[num_total].lhs[0] = j;
						relation_[num_total].lhs[2] = -1;
					// manufacture the other side of the relation;
						relation_[num_total].rhs[0] = product_.arrow_number("(1" + product_.obj[product_.arr[j][1]].split("`")[0] + "`" + current_[1]);//j
						relation_[num_total].rhs[1] = product_.arrow_number(check_[0] + "`1" + product_.obj[product_.arr[i][0]].split("`")[1] + ")");
						relation_[num_total++].rhs[2] = -1;
					}
				}						
			}
		}	

		for (int i=0; i<num_total; i++)
			product_.relations[product_.num_relations++] = relation_[i];
	}
	
}