
import java.io.*;
import javax.swing.*;

public class SaveFileWriter
{
	JInternalFrame internalFrame_;
	Category category_;
	FunctorNode functor_;
	BufferedWriter output;
	File file_;
	
	public SaveFileWriter(File file, CategoryInternalFrame categoryInternalFrame)
	{
		internalFrame_ = categoryInternalFrame;
		category_ = ((CategoryInternalFrame)internalFrame_).getCategory();
		file_ = file;
		try
		{
			output = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(file_)));
			category_.name = file_.getName();
			category_.file_ = file_;
		}
		catch(IOException e)
		{
			JOptionPane.showInternalMessageDialog(internalFrame_, "Unable to save file " + file_.getName(), "Error", JOptionPane.ERROR_MESSAGE);
		}
	}
	
	public SaveFileWriter(File file, FunctorInternalFrame functorInternalFrame)
	{
		internalFrame_ = functorInternalFrame;
		functor_ = ((FunctorInternalFrame)internalFrame_).getFunctor();
		file_ = file;
		try
		{
			output = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(file_)));
			functor_.f.name = file_.getName();
			functor_.f.filename = file_.getName();
		}
		catch (IOException e)
		{
			JOptionPane.showInternalMessageDialog(internalFrame_, "Unable to save file " + file_.getName(), "Error", JOptionPane.ERROR_MESSAGE);
		}
	}
	
	public void saveFunctor()
	{
		category_ = functor_.A;
		saveCategory();
		category_ = functor_.B;
		saveCategory();

		int i=0, j;
		try
		{
			try
			{
				output.write("\nfunctor\n " + functor_.f.name + "\n");		//Display functor name
		
				output.write("objects\n");		//Display functor objects
				for (i=0;i<functor_.A.num_objects-1;i++)
					output.write(functor_.A.obj[i] + " |--> " + functor_.B.obj[functor_.f.obj[i]] + ", ");

				output.write(functor_.A.obj[i] + " |--> " + functor_.B.obj[functor_.f.obj[i]] + ".\n");
		
				output.write("arrows\n");		//Display functor arrows
				for (i=0;i<functor_.A.num_arrows-1;i++)
				{
					output.write(functor_.A.arrow[i] + " |--> ");
					j = 0;
					while (functor_.f.arr[i][j] != -1 && functor_.f.arr[i][j] != -2)
					{
						output.write("" + functor_.B.arrow[functor_.f.arr[i][j]]);
						j++;
					}
					if (j==0)
					output.write("1");
					output.write(", ");
				}
				if (functor_.A.num_arrows != 0)
				{
					output.write(functor_.A.arrow[i] + " |--> ");
					j = 0;
					while (functor_.f.arr[i][j] != -1 && functor_.f.arr[i][j] != -2)
					{
						output.write("" + functor_.B.arrow[functor_.f.arr[i][j]]);
						j++;
					}
					if (j==0)
						output.write("1");
					output.write(".\n");
				}
				else
					output.write(".\n");
			}
			catch(EOFException eof) {}
		}
		catch (IOException e1) {}
		try
		{
			output.close();
		}
		catch (IOException e1) {}
	}

	
	public void saveCategory()
	//This method saves the text and graphical versions of a category file (*.CGL)
	{
		try
		{
			try {
				String comments = category_.comment;
//				System.out.println("comments: " + comments);
				if (!comments.equals(""))
				    output.write("#" + comments + "\n");
				output.write("category\n" + category_.name + "\n");
//				System.out.println("name: " + category_.name);
				output.write("objects\n" + objectsToString() + "\n");
//				System.out.println("objects: " + objectsToString());
				output.write("arrows\n" + arrowsToString() + "\n");
//				System.out.println("arrows: " + arrowsToString());
				String relations = category_.relationsToString();
				if (relations.equals(""))
					relations += ".";
				output.write("relations\n" + relations + "\n");
//				System.out.println("relations: " + relations);
//				if (file_.getName().toLowerCase().endsWith(".cgl") || file_.getName().toLowerCase().endsWith(".fgl"))
				output.write("gml\n" + category_.gml + "\n");
			}
			catch(EOFException eof) {System.out.println("eof exception");}
			if (functor_ == null)
				output.close();
		}
		catch (IOException e1) {System.out.println("io exception");e1.printStackTrace();}
		
	}
	
	private String objectsToString()
	{
		String objects_ = "";
		for (int i=0; i<category_.num_objects-1; i++)
		{
			objects_ += category_.obj[i] + ", ";
		}
		if (category_.num_objects != 0)
			objects_ += category_.obj[category_.num_objects - 1] + ".\n";
		else
			objects_ += ".";
		return objects_;
	}
	
	private String arrowsToString()
	{
		String arrows_ = "";
		for (int i = 0; i < category_.num_arrows-1; i++)
		{
			arrows_ += category_.arrow[i] + ":";
			arrows_ += category_.obj[category_.arr[i][0]] + "->";
			arrows_ += category_.obj[category_.arr[i][1]] + ", ";
		}
		if (category_.num_arrows != 0)
		{
			arrows_ += category_.arrow[category_.num_arrows-1] + ":";
			arrows_ += category_.obj[category_.arr[category_.num_arrows-1][0]] + "->";
			arrows_ += category_.obj[category_.arr[category_.num_arrows-1][1]] +". ";
		}
		else
			arrows_ += ".";
		return arrows_;
	}
}